/[MITgcm]/MITgcm/verification/testreport
ViewVC logotype

Contents of /MITgcm/verification/testreport

Parent Directory Parent Directory | Revision Log Revision Log | View Revision Graph Revision Graph


Revision 1.44 - (show annotations) (download)
Mon Jul 12 14:02:25 2004 UTC (19 years, 8 months ago) by edhill
Branch: MAIN
Changes since 1.43: +10 -8 lines
 o reduce size of verif emails--do not include Makefile or output.txt

1 #! /usr/bin/env bash
2 #
3 # $Header: /u/gcmpack/MITgcm/verification/testreport,v 1.43 2004/07/08 20:58:24 edhill Exp $
4 # $Name: $
5 #
6
7 usage()
8 {
9 echo
10 echo "Usage: $0 [OPTIONS]"
11 echo
12 echo "where possible OPTIONS are:"
13 echo " (-help|-h) print usage"
14 echo " (-mpi) use MPI input files"
15 echo " (-ieee|-noieee) if possible, use IEEE compiler flags"
16 echo " (DEF=\"-ieee\")"
17 echo " (-optfile=|-of=)STRING list of optfiles to use"
18 echo " (-a|-addr) STRING list of email recipients"
19 echo " (DEF=\"edhill@mitgcm.org\")"
20 echo " (-t|-tdir) STRING list of test dirs to use"
21 echo " (DEF=\"\" which builds all)"
22 echo " (-b|-bash) STRING preferred location of a \"bash\" or"
23 echo " Bourne-compatible \"sh\" shell"
24 echo " (DEF=\"\" for \"bash\")"
25 echo " (-adm|-ad) perform an adjoint run"
26 echo " (-command) STRING command to run"
27 echo " (DEF=\"make output.txt\")"
28 echo " (-m|-make) STRING command to use for \"make\""
29 echo " (DEF=\"make\")"
30 echo " (-j) JOBS use \"make -j JOBS\" for parallel builds"
31 echo " (-clean) *ONLY* run \"make CLEAN\""
32 echo " (-quick|-q) same as \"-nogenmake -noclean -nodepend\""
33 echo " (-nogenmake|-ng) skip the genmake stage"
34 echo " (-noclean|-nc) skip the \"make clean\" stage"
35 echo " (-nodepend|-nd) skip the \"make depend\" stage"
36 echo " (-deldir|-dd) on success, delete the output directory"
37 echo
38 echo "and where STRING follows a whitespace-delimited format"
39 echo "such as:"
40 echo " -t 'exp0 exp2 exp3' "
41 echo " -addr='abc@123.com testing@home.org'"
42 echo
43 exit 1
44 }
45
46 # build the mpack utility
47 build_mpack()
48 {
49 printf "building the mpack utility... "
50 if test ! -x "$MPACKDIR/mpack" ; then
51 if test ! -d $MPACKDIR ; then
52 echo
53 echo "Error: can't find \"$MPACKDIR\""
54 echo " are you sure this program is being run in the correct "
55 echo " (that is, \"MITGCM_ROOT\verification\") directory?"
56 echo
57 HAVE_MPACK=f
58 fi
59 printf "building mpack... "
60 if test "x$CC" = x ; then
61 export CC=cc
62 fi
63 ( cd $MPACKDIR && ./configure && $MAKE ) > tr_build_mpack.out 2>&1
64 RETVAL=$?
65 if test "x$RETVAL" != x0 ; then
66 echo
67 echo "Error building the mpack tools at: $MPACK_DIR"
68 echo
69 HAVE_MPACK=f
70 else
71 rm -f tr_build_mpack.out
72 HAVE_MPACK=t
73 fi
74 else
75 HAVE_MPACK=t
76 fi
77 echo "OK"
78 }
79
80 testoutput_for_prop()
81 {
82 # testoutput_for_prop dir s1 label subdir extension
83 #
84 # compares files in $dir/$subdir/output.txt and $dir/results/output.txt
85 # using search strings s1 and text label
86
87 if [ $debug -gt 0 ]; then
88 echo testoutput_for_prop: grep "$2" $1/$4/output.txt 1>&2
89 fi
90 if [ -r $1/$4/output.txt ]; then
91 grep "$2" $1/$4/output.txt | sed 's/.*=//' | cat -n > tmp1.txt
92 lncnt=`wc -l tmp1.txt | awk '{print $1}' `
93 if [ $lncnt -lt 3 ]; then
94 if [ $verbose -gt 0 ]; then
95 echo Not enough lines of output when searching for "$2" 1>&2
96 fi
97 return 99
98 fi
99 else
100 echo testoutput_for_prop: output.txt from model run was not readable 1>&2
101 return 99
102 fi
103 if [ $debug -gt 0 ]; then
104 echo testoutput_for_prop: grep "$2" $1/results/output.txt$5 1>&2
105 fi
106 grep "$2" $1/results/output.txt$5 | sed 's/.*=//' | cat -n > tmp2.txt
107 lncnt=`wc -l tmp2.txt | awk '{print $1}' `
108 if [ $lncnt -lt 3 ]; then
109 if [ $verbose -gt 0 ]; then
110 echo Not enough lines of output when searching for "$2" 1>&2
111 fi
112 return 99
113 fi
114 if [ $debug -gt 0 ]; then
115 echo testoutput_for_prop: join tmp1.txt tmp2.txt 1>&2
116 fi
117 join tmp1.txt tmp2.txt | awk '{print $1 " " $2 " " $3}' > tmp3.txt
118 if [ $debug -gt 0 ]; then
119 echo testoutput_for_prop: compare_lines 1>&2
120 fi
121 if [ $verbose -gt 1 ]; then
122 cat tmp3.txt 1>&2
123 fi
124 echo "-1" >> tmp3.txt
125 # On the SGI O3K (*not* the O2K), "cat -n" inserts a ":" after the line number
126 cat tmp3.txt | sed -e 's|:||g' > tmp4.txt
127 digits_of_similarity=`./tmp_cmpnum < tmp4.txt`
128 if [ $digits_of_similarity -eq 99 ]; then
129 if [ $verbose -gt 0 ]; then
130 echo testoutput_for_prop: No comparison was available for \"$2\" 1>&2
131 fi
132 digits_of_similarity=99
133 else
134 if [ $verbose -gt 0 ]; then
135 echo There were $digits_of_similarity decimal places of similarity for \"$2\" 1>&2
136 fi
137 fi
138 rm -f tmp1.txt tmp2.txt tmp3.txt tmp4.txt
139
140 return $digits_of_similarity
141 }
142
143 dashnum()
144 {
145 # dashnum n1 n2 n3 ...
146 #
147 # print numbers using %3i format or "--" if number = 99
148
149 for num in $@ ; do
150 if [ $num = 99 ]; then
151 printf ' --'
152 else
153 printf '%3i' $num
154 fi
155 done
156 }
157
158 testoutput_ad()
159 {
160 grep $3 $1/results_ad/output.txt_adm | awk '{print NR " " $5}' > t05.txt
161 grep $3 $1/$2/output.txt_adm | awk '{print NR " " $5}' > t15.txt
162 grep $3 $1/results_ad/output.txt_adm | awk '{print NR " " $6}' > t06.txt
163 grep $3 $1/$2/output.txt_adm | awk '{print NR " " $6}' > t16.txt
164 join t05.txt t15.txt > t5.txt
165 join t06.txt t16.txt > t6.txt
166 echo "-1" >> t5.txt
167 echo "-1" >> t6.txt
168 digits_5=`./tmp_cmpnum < t5.txt`
169 digits_6=`./tmp_cmpnum < t6.txt`
170 dashnum $digits_5 $digits_6
171 rm -f t[01][56].txt t[56].txt
172 }
173
174 testoutput()
175 {
176 # testoutput directory subdir extension
177 #
178 # test output in "directory"
179 if test "x$ADM" = x ; then
180 if [ $debug -gt 0 ]; then
181 echo testoutput: testoutput_for_prop $1 cg2d_init_res 1>&2
182 fi
183 testoutput_for_prop $1 "cg2d_init_res" "cg2d init. residual" $2 $3; cg2dres=$?
184 if [ $debug -gt 0 ]; then
185 echo testoutput: cg2dres=$cg2dres 1>&2
186 fi
187 testoutput_for_prop $1 "dynstat_theta_min" "theta minimum" $2 $3; tmin=$?
188 testoutput_for_prop $1 "dynstat_theta_max" "theta maximum" $2 $3; tmax=$?
189 testoutput_for_prop $1 "dynstat_theta_mean" "theta mean" $2 $3; tmean=$?
190 testoutput_for_prop $1 "dynstat_theta_sd" "theta s.d." $2 $3; tsd=$?
191 testoutput_for_prop $1 "dynstat_salt_min" "salt minimum" $2 $3; smin=$?
192 testoutput_for_prop $1 "dynstat_salt_max" "salt maximum" $2 $3; smax=$?
193 testoutput_for_prop $1 "dynstat_salt_mean" "salt mean" $2 $3; smean=$?
194 testoutput_for_prop $1 "dynstat_salt_sd" "salt s.d." $2 $3; ssd=$?
195 testoutput_for_prop $1 "dynstat_uvel_min" "U minimum" $2 $3; umin=$?
196 testoutput_for_prop $1 "dynstat_uvel_max" "U maximum" $2 $3; umax=$?
197 testoutput_for_prop $1 "dynstat_uvel_mean" "U mean" $2 $3; umean=$?
198 testoutput_for_prop $1 "dynstat_uvel_sd" "U s.d." $2 $3; usd=$?
199 testoutput_for_prop $1 "dynstat_vvel_min" "V minimum" $2 $3; vmin=$?
200 testoutput_for_prop $1 "dynstat_vvel_max" "V maximum" $2 $3; vmax=$?
201 testoutput_for_prop $1 "dynstat_vvel_mean" "V mean" $2 $3; vmean=$?
202 testoutput_for_prop $1 "dynstat_vvel_sd" "V s.d." $2 $3; vsd=$?
203 dashnum $cg2dres $tmin $tmax $tmean $tsd $smin $smax $smean $ssd \
204 $umin $umax $umean $usd $vmin $vmax $vmean $vsd
205 else
206 testoutput_ad $1 $2 "precision_grdchk_result"
207 fi
208 }
209
210 genmakemodel()
211 {
212 # genmakemodel directory
213 if test "x$NOGENMAKE" = xt ; then
214 echo "genmake skipped!"
215 else
216 if test "x$BASH" = x ; then
217 GENMAKE2="../../../tools/genmake2"
218 else
219 GENMAKE2="$BASH ../../../tools/genmake2 -bash $BASH"
220 fi
221 (
222 cd $1;
223 command="$GENMAKE2 -ds -m $MAKE"
224 if test "x$ADM" = x ; then
225 command="$command --mods=../code"
226 else
227 command="$command --mods=../code_ad"
228 command="$command -adof=../../../tools/adjoint_options/adjoint_staf"
229 fi
230 if test "x$OPTFILE" != xNONE ; then
231 command="$command --optfile=$OPTFILE"
232 fi
233 if test "x$IEEE" != x ; then
234 command="$command -ieee"
235 fi
236 printf 'genmake ... ' 1>&2
237 $command > make.log 2>&1
238 RETVAL=$?
239 # Reduce the size of the testing emails!
240 # cp Makefile $CDIR
241 if test "x$RETVAL" != x0 ; then
242 tail make.log
243 echo "genmakemodel: genmake failed" 1>&2
244 cp genmake_* make.log $CDIR
245 return 1
246 else
247 echo "successful" 1>&2
248 fi
249 )
250 fi
251 }
252
253 makeclean()
254 {
255 # makeclean directory
256 if test "x$NOCLEAN" = xt ; then
257 echo "make CLEAN skipped!"
258 else
259 (
260 cd $1;
261 if test -e output.txt ; then
262 rm -f output.txt
263 fi
264 printf 'make CLEAN ... ' 2>&1
265 if test -r Makefile ; then
266 $MAKE CLEAN >> make.log 2>&1
267 RETVAL=$?
268 if test "x$RETVAL" != x0 ; then
269 tail make.log
270 echo "makeclean: \"make CLEAN\" failed" 1>&2
271 cp make.log $CDIR"/make.log"
272 return 1
273 fi
274 fi
275 echo successful 1>&2
276 exit 0
277 )
278 fi
279 }
280
281 makedependmodel()
282 {
283 # makedependmodel directory
284 if test "x$NODEPEND" = xt ; then
285 echo "make depend skipped!"
286 else
287 (
288 cd $1;
289 printf 'make depend ... ' 1>&2
290 $MAKE depend >> make.log 2>&1
291 RETVAL=$?
292 if test "x$RETVAL" != x0 ; then
293 tail make.log
294 echo "makedependmodel: make depend failed" 1>&2
295 cp make.log $CDIR"/make.log"
296 return 1
297 else
298 echo successful 1>&2
299 fi
300 )
301 fi
302 }
303
304 makemodel()
305 {
306 # makemodel directory
307 (
308 cd $1;
309 if test -r Makefile ; then
310 printf 'make ... ' 1>&2
311 if test "x$ADM" = x ; then
312 if test "x$JOBS" = x ; then
313 $MAKE >> make.log 2>&1
314 else
315 $MAKE -j $JOBS >> make.log 2>&1
316 fi
317 else
318 $MAKE adall >> make.log 2>&1
319 fi
320 RETVAL=$?
321 if test "x$RETVAL" != x0 ; then
322 tail make.log
323 echo failed 1>&2
324 cp make.log $CDIR"/make.log"
325 return 1
326 else
327 echo successful 1>&2
328 fi
329 fi
330 )
331 }
332
333 symlink_mpifiles()
334 {
335 # Put special links so that MPI specific files are used
336 # This MUST be invoked between makeclean and makelinks because
337 # the Makefile will link to non-mpi files by default
338
339 dir=$1
340 code_dir=$2
341 BUILD_DIR=$dir/$3
342 CODE_DIR=$dir/$code_dir
343
344 # These are files that should replace their counter-part when using -mpi
345 MPI_FILES=`(cd $CODE_DIR; find . -name "*_mpi")`
346
347 # Is this an MPI run?
348 if test "x$MPI" = xt ; then
349 # YES: We symbolically link these files to the build
350 # dir so long as there is no real file in place
351 for ii in $MPI_FILES ; do
352 i=`echo $ii | sed 's:^\./::'`
353 name=`echo $i | sed 's:_mpi::' `
354 cmp $CODE_DIR/$i $BUILD_DIR/$name > /dev/null 2>&1
355 RETVAL=$?
356 if test "x$RETVAL" != x0 ; then
357 if ! test -f $BUILD_DIR/$i ; then
358 #echo Linking $name to $i
359 (cd $BUILD_DIR; ln -sf ../$code_dir/$i $name)
360 fi
361 fi
362 done
363 else
364 # NO: We undo any _mpi symbolically linked files
365 for ii in $MPI_FILES ; do
366 i=`echo $ii | sed 's:^\./::'`
367 name=`echo $i | sed 's:_mpi::' `
368 if test -L $BUILD_DIR/$name ; then
369 linktarg=`(cd $BUILD_DIR; readlink $name)`
370 if test $linktarg = "../$code_dir/$name"_mpi ; then
371 #echo Un-linking $name from $linktarg
372 rm -f $BUILD_DIR/$name
373 fi
374 fi
375 done
376 fi
377
378 }
379
380 linkdata()
381 {
382 # linkdata flag
383 #
384 # symbolically link data files to run directory
385 if test "x$1" = x1 ; then
386 (
387 cd $2
388 if test "x$ADM" = x ; then
389 files=`( cd ../input ; ls -1 | grep -v CVS )`
390 for i in $files ; do
391 if test ! -d "../input/"$i ; then
392 ln -sf "../input/"$i $i
393 fi
394 done
395 else
396 files=`( cd ../input ; ls -1 *.bin | grep -v CVS )`
397 for i in $files ; do
398 if test ! -d "../input/"$i ; then
399 ln -sf "../input/"$i $i
400 fi
401 done
402 files=`( cd ../input_ad ; ls -1 | grep -v CVS )`
403 for i in $files ; do
404 if test ! -d "../input_ad/"$i ; then
405 ln -sf "../input_ad/"$i $i
406 fi
407 done
408 fi
409 )
410 fi
411 }
412
413 runmodel()
414 {
415 # runmodel directory
416 #
417 # runs "$COMMAND in "directory"
418 # (where "$COMMAND" is relative to "directory")
419 (
420 cd $1
421 printf 'runmodel ... ' 1>&2
422 # make output.txt
423 echo
424 # echo "COMMAND='$COMMAND'"
425 # echo "pwd='"`pwd`"'"
426 ( eval $COMMAND ) >> run.log 2>&1
427 RETVAL=$?
428 if test "x$RETVAL" = x0 ; then
429 echo successful 1>&2
430 # === Reduce the size of the testing emails!
431 # if test "x$ADM" = x ; then
432 # cp output.txt $CDIR"/output.txt"
433 # else
434 # cp output.txt_adm $CDIR"/output.txt_adm"
435 # fi
436 return 0
437 else
438 tail run.log
439 echo failed 1>&2
440 cp run.log $CDIR"/run.log"
441 return 1
442 fi
443 )
444 }
445
446 createcodelet()
447 {
448 # create codelet for comparing model output
449
450 printf "creating the comparison code... "
451 cat > tmp_cmpnum.c <<EOF
452 #include <stdio.h>
453 #include <math.h>
454 int main( int argc, char** argv ) {
455 int linnum,best,lncnt;
456 double a,b,diff;
457 best = -16;
458 lncnt = 0;
459 while( 1 & (lncnt+=1) < 999 ) {
460 scanf("%d", &linnum);
461 if (linnum == -1) break;
462 scanf("%lf", &a); scanf("%lf", &b);
463 diff = 0.5*(fabs(a)+fabs(b));
464 if (diff > 1.e-12) {
465 diff=fabs(a-b)/diff;
466 if (diff > 0.0) {
467 linnum = (int)log10(diff);
468 best = (best > linnum) ? best : linnum;
469 }
470 else {
471 if (best == -16 && diff != 0) best = -22;
472 }
473 }
474 }
475 if (lncnt == 999) best=-29;
476 printf("%d\n", -best);
477 return 0;
478 }
479 EOF
480 cc -o tmp_cmpnum tmp_cmpnum.c -lm
481
482 if [ -x ./tmp_cmpnum ]; then
483 echo "OK"
484 return 0
485 else
486 echo
487 echo "ERROR: failed to compile comparison code"
488 exit 1
489 fi
490 }
491
492 formatresults()
493 {
494 # formatresults expt genmake depend make run results*
495
496 nm=$1
497 printf '%s %s %s %s' $2 $3 $4 $5
498 shift; shift; shift; shift; shift;
499 printf '%3s' $@
500
501 if [ $1 = '--' ]; then
502 printf ' N/O '
503 else
504 if [ $1 -gt 12 ]; then
505 printf ' pass'
506 else
507 printf ' FAIL'
508 fi
509 fi
510 printf ' %s' $nm
511 printf '\n'
512
513 }
514
515 show_help()
516 {
517 cat - << EOF
518 $0 [-help] [-quick] [-verbose] dir1 [dir2] [...]
519
520 -help|-h Show this help message
521 -quiet Reduce the amount of output
522 -verbose Produce copious amounts of output
523 -debug Produce even more output which will mean nothing to most
524 -force Do "make CLEAN" before compiling. This forces a complete rebuild.
525 -clean Do "make CLEAN" after compiling and testing.
526 -cleanup Aggresively removes all model output, executables and object files
527 and then exits. Use with care.
528
529 Normal usage:
530 $0 * Configure, compile, run and analyze in all experiment directories
531 EOF
532 }
533
534 scandirs()
535 {
536 if [ $# -eq 0 ]; then
537 for arg in * ; do
538 test -d $arg/input && echo $arg
539 done
540 else
541 echo $*
542 fi
543 }
544
545
546 ###############################################################################
547
548
549 # Default properties
550 debug=0
551 verbose=1
552 clean=0
553 expts=''
554 # ieee=1
555
556 IEEE=true
557 if test "x$MITGCM_IEEE" != x ; then
558 IEEE=$MITGCM_IEEE
559 fi
560
561
562 CLEANUP=f
563 QUICK=f
564 NOGENMAKE=f
565 NOCLEAN=f
566 NODEPEND=f
567
568 BASH=
569 OPTFILE=NONE
570 ADDRESSES=
571 TESTDIRS=
572 MPACKDIR="../tools/mpack-1.6"
573 HAVE_MPACK=
574 MPACK="$MPACKDIR/mpack"
575 COMMAND=
576 MAKE=make
577 JOBS=
578 MPI=f
579 DELDIR=
580
581 ADM=
582
583 printf "parsing options... "
584
585 ac_prev=
586 for ac_option ; do
587
588 # If the previous option needs an argument, assign it.
589 if test -n "$ac_prev"; then
590 eval "$ac_prev=\$ac_option"
591 ac_prev=
592 continue
593 fi
594
595 ac_optarg=`expr "x$ac_option" : 'x[^=]*=\(.*\)'`
596
597 case $ac_option in
598
599 -help | --help | -h | --h)
600 usage ;;
601
602 -optfile | --optfile | -of | --of)
603 ac_prev=OPTFILE ;;
604 -optfile=* | --optfile=* | -of=* | --of=*)
605 OPTFILE=$ac_optarg ;;
606
607 -addr | --addr | -a | --a)
608 ac_prev=ADDRESSES ;;
609 -addr=* | --addr=*)
610 ADDRESSES=$ac_optarg ;;
611
612 -tdir | --tdir | -t | --t)
613 ac_prev=TESTDIRS ;;
614 -tdir=* | --tdir=*)
615 TESTDIRS=$ac_optarg ;;
616
617 -bash | --bash | -b | --b)
618 ac_prev=BASH ;;
619 -bash=* | --bash=*)
620 BASH=$ac_optarg ;;
621
622 -command | --command | -c | --c)
623 ac_prev=COMMAND ;;
624 -command=* | --command=*)
625 COMMAND=$ac_optarg ;;
626
627 -make | --make | -m | --m)
628 ac_prev=MAKE ;;
629 -make=* | --make=*)
630 MAKE=$ac_optarg ;;
631
632 -j) ac_prev=JOBS ;;
633 -j=*) JOBS=$ac_optarg ;;
634
635 -clean | --clean)
636 CLEANUP=t ;;
637
638 -quick | --quick | -q | --q)
639 QUICK=t ;;
640 -nogenmake | --nogenmake | -ng | --ng)
641 NOGENMAKE=t ;;
642 -noclean | --noclean | -nc | --nc)
643 NOCLEAN=t ;;
644 -nodepend | --nodepend | -nd | --nd)
645 NODEPEND=t ;;
646
647 -mpi) MPI=t ;;
648
649 -adm | -ad) ADM=t ;;
650
651 -ieee) IEEE=true ;;
652 -noieee) IEEE= ;;
653
654 -verbose) verbose=2 ;;
655 -debug) debug=1 ;;
656 -quiet) verbose=0 ;;
657
658 -deldir | -dd) DELDIR=t ;;
659
660 -*)
661 echo "Error: unrecognized option: "$ac_option
662 usage
663 ;;
664
665 *)
666 echo "Error: unrecognized argument: "$ac_option
667 usage
668 ;;
669
670 esac
671
672 done
673
674 if test "x$QUICK" = xt ; then
675 NOGENMAKE=t
676 NOCLEAN=t
677 NODEPEND=t
678 fi
679
680 if test "x$TESTDIRS" = x ; then
681 TESTDIRS=`scandirs`
682 fi
683
684 if test "x$OPTFILE" = xNONE -a "x$MITGCM_OF" != x ; then
685 OPTFILE=$MITGCM_OF
686 fi
687
688 if test "x$ADM" = xt -a "x$COMMAND" = x ; then
689 COMMAND="./mitgcmuv_ad > output.txt_adm 2>&1"
690 fi
691
692 if test "x$COMMAND" = x ; then
693 COMMAND="make output.txt"
694 fi
695
696 echo "OK"
697
698 # create the FORTRAN comparison code
699 createcodelet
700
701 # build the mpack utility
702 if test "x$ADDRESSES" = xNONE -o "x$ADDRESSES" = x ; then
703 echo "skipping mpack build"
704 else
705 build_mpack
706 fi
707
708 # Create a uniquely named directory to store results
709 MACH=`hostname`
710 UNAMEA=`uname -a`
711 DATE=`date +%Y%m%d`
712 BASE="tr_"$MACH"_"$DATE"_"
713 DNUM=0
714 DRESULTS="$BASE$DNUM"
715 while test -e $DRESULTS ; do
716 DNUM=$(( $DNUM + 1 ))
717 DRESULTS="$BASE$DNUM"
718 done
719 mkdir $DRESULTS
720 RETVAL=$?
721 if test "x$RETVAL" != x0 ; then
722 echo "ERROR: Can't create results directory \"./$DRESULTS\""
723 exit 1
724 fi
725 SUMMARY="$DRESULTS/summary.txt"
726 printf "Start time: " >> $SUMMARY
727 start_date=`date`
728 echo $start_date > $SUMMARY
729
730 of_path=
731 if test "x$OPTFILE" != xNONE ; then
732 if test -r $OPTFILE ; then
733 # get the path
734 path=${OPTFILE%/*}
735 if test "x$path" = x ; then
736 of_path=`pwd`
737 else
738 of_path=`( cd $path > /dev/null 2>&1 ; pwd )`
739 fi
740 file=${OPTFILE##*/}
741 OPTFILE=$of_path/$file
742 cp $OPTFILE $DRESULTS
743 echo >> $SUMMARY
744 echo " OPTFILE=$OPTFILE" >> $SUMMARY
745 else
746 echo | tee $SUMMARY
747 echo "ERROR: can't read OPTFILE=\"$OPTFILE\"" | tee $SUMMARY
748 exit 1
749 fi
750 else
751 echo >> $SUMMARY
752 echo "No \"OPTFILE\" was explicitly specified by testreport," >> $SUMMARY
753 echo " so the genmake default will be used." >> $SUMMARY
754 fi
755 echo
756 echo >> $SUMMARY
757 if test "x$ADM" = x ; then
758 cat << EOF | tee -a $SUMMARY
759 T S U V
760 G D M c m s m s m s m s
761 E p a R g m m e . m m e . m m e . m m e .
762 N n k u 2 i a a d i a a d i a a d i a a d
763 2 d e n d n x n . n x n . n x n . n x n .
764
765 EOF
766 else
767 echo "ADJOINT=true" >> $SUMMARY
768 echo >> $SUMMARY
769 cat << EOF | tee -a $SUMMARY
770 G D M C G
771 E p a R o r
772 N n k u s a
773 2 d e n t d
774
775 EOF
776 fi
777
778 # ...and each test directory...
779 for dir in $TESTDIRS ; do
780
781 # Cleanup only!
782 if test "x$CLEANUP" = xt ; then
783 if test -r $dir/build/Makefile ; then
784 ( cd $dir/build ; make CLEAN )
785 fi
786 if test -r $dir/input/Makefile ; then
787 ( cd $dir/input ; make CLEAN )
788 fi
789 continue
790 fi
791
792 # Verify that the testdir exists and contains previous
793 # results in the correct location--or skip this directory!
794 fout=
795 if test "x$ADM" = x ; then
796 fout=$dir"/results/output.txt"
797 else
798 fout=$dir"/results_ad/output.txt_adm"
799 fi
800 if test ! -r $fout ; then
801 echo "can't read \"$fout\" -- skipping $dir"
802 continue
803 fi
804
805 builddir="input"
806 rundir="input"
807 use_seperate_build=0
808 if test -d $dir/build -a -r $dir/build ; then
809 builddir="build"
810 rundir="build"
811 use_seperate_build=1
812 linkdata $use_seperate_build $dir/$rundir
813 fi
814
815 # Check whether there are "extra runs" for this testdir
816 extra_runs=
817 if test "x$ADM" = x -a "x$use_seperate_build" = x1 ; then
818 ex_run_dirs=`( cd $dir ; echo input.* )`
819 echo "ex_run_dirs='$ex_run_dirs'"
820 for exd in $ex_run_dirs ; do
821 name=`echo $exd | sed -e 's/input.//g'`
822 outf="$dir/results/output.txt.$name"
823 if test -f $outf -a -r $outf ; then
824 extra_runs="$extra_runs $name"
825 fi
826 done
827 fi
828
829 if test "x$ADM" = x ; then
830 code_dir=code
831 CODE_DIR=$dir/code
832 else
833 code_dir=code_ad
834 CODE_DIR=$dir/code_ad
835 fi
836 BUILD_DIR=$dir/$builddir
837
838 if test ! -r $CODE_DIR"/SIZE.h_mpi" -a "x$MPI" = "xt" ; then
839 echo "can't find \"$CODE_DIR/SIZE.h_mpi\" -- skipping $dir"
840 continue
841 fi
842
843 echo "-------------------------------------------------------------------------------"
844 echo
845 echo "Experiment: $dir"
846 echo
847 unset genmake makedepend make run
848 results='-- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- --'
849
850 # Create an output dir for each OPTFILE/tdir combination
851 rel_CDIR=$DRESULTS"/"$dir
852 mkdir $rel_CDIR
853 CDIR=`pwd`"/$rel_CDIR"
854
855 if test "x$CLEANUP" = xt ; then
856 makeclean $dir/$builddir
857 else
858 genmakemodel $dir/$builddir && genmake=Y \
859 && makeclean $dir/$builddir \
860 && symlink_mpifiles $dir $code_dir $builddir \
861 && makedependmodel $dir/$builddir && makedepend=Y \
862 && makemodel $dir/$builddir && make=Y \
863 && linkdata $use_seperate_build $dir/$rundir \
864 && runmodel $dir/$rundir && run=Y \
865 && results=`testoutput $dir $rundir`
866 fi
867
868 echo
869 if test "x$ADM" = x ; then
870 fres=`formatresults $dir ${genmake:-N} ${makedepend:-N} ${make:-N} ${run:-N} $results`
871 echo
872 echo "$fres" >> $SUMMARY
873 echo "fresults='$fres'" > $CDIR"/summary.txt"
874 echo "MACH='$MACH'" >> $CDIR"/summary.txt"
875 echo "UNAMEA='$UNAMEA'" >> $CDIR"/summary.txt"
876 echo "DATE='$DATE'" >> $CDIR"/summary.txt"
877 echo "tdir='$dir'" >> $CDIR"/summary.txt"
878
879 OLD_COMMAND=$COMMAND
880 COMMAND="./mitgcmuv > output.txt"
881 for ex in $extra_runs ; do
882 test -e "$dir/tr_run.$ex" && rm -rf "$dir/tr_run.$ex"
883 mkdir "$dir/tr_run.$ex"
884 links=`( cd "$dir/input" > /dev/null 2>&1 ; ls -1 | grep -v CVS )`
885 (
886 cd "$dir/tr_run.$ex"
887 for i in $links; do
888 ln -s ../input/$i $i
889 done
890 )
891 links=`( cd "$dir/input.$ex" > /dev/null 2>&1 ; ls -1 | grep -v CVS )`
892 (
893 cd "$dir/tr_run.$ex"
894 for i in $links; do
895 test -e $i && rm -f $i
896 ln -s ../input.$ex/$i $i
897 done
898 ln -s ../$builddir/mitgcmuv mitgcmuv
899 )
900 runmodel $dir/tr_run.$ex && run=Y \
901 && results=`testoutput $dir tr_run.$ex "."$ex`
902 fres=`printf '%s %s %s %s' ${genmake:-N} ${makedepend:-N} ${make:-N} ${run:-N}`
903 fres=`formatresults $dir ${genmake:-N} ${makedepend:-N} ${make:-N} ${run:-N} $results`
904 fres="$fres.$ex"
905 echo
906 echo "$fres" >> $SUMMARY
907 echo "fresults='$fres'" > $CDIR"/summary.txt"
908 echo "MACH='$MACH'" >> $CDIR"/summary.txt"
909 echo "UNAMEA='$UNAMEA'" >> $CDIR"/summary.txt"
910 echo "DATE='$DATE'" >> $CDIR"/summary.txt"
911 echo "tdir='$dir'" >> $CDIR"/summary.txt"
912 done
913 COMMAND=$OLD_COMMAND
914 else
915 fres=`printf '%s %s %s %s' ${genmake:-N} ${makedepend:-N} ${make:-N} ${run:-N}`
916 fres=$fres"$results $dir"
917 echo
918 echo "$fres" >> $SUMMARY
919 echo "fresults='$fres'" > $CDIR"/summary.txt"
920 echo "MACH='$MACH'" >> $CDIR"/summary.txt"
921 echo "UNAMEA='$UNAMEA'" >> $CDIR"/summary.txt"
922 echo "DATE='$DATE'" >> $CDIR"/summary.txt"
923 echo "tdir='$dir'" >> $CDIR"/summary.txt"
924 fi
925
926 echo "-------------------------------------------------------------------------------"
927
928 done
929
930 printf "Start time: " >> $SUMMARY
931 echo $start_date >> $SUMMARY
932 printf "End time: " >> $SUMMARY
933 date >> $SUMMARY
934
935 # If addresses were supplied and mpack built successfully, then try
936 # to send email using mpack.
937 if test "x$ADDRESSES" = xNONE -o "x$ADDRESSES" = x ; then
938 echo "No results email was sent."
939 else
940 if test "x$HAVE_MPACK" = xt ; then
941 tar -cf $DRESULTS".tar" $DRESULTS > /dev/null 2>&1 \
942 && gzip $DRESULTS".tar" \
943 && $MPACK -s MITgcm-test -m 3555000 $DRESULTS".tar.gz" $ADDRESSES
944 RETVAL=$?
945 if test "x$RETVAL" != x0 ; then
946 echo
947 echo "Warning: The tar, gzip, & mpack step failed. Please send email"
948 echo " to <MITgcm-support@mitgcm.org> for help. You may copy the "
949 echo " summary of results from the directory \"$DRESULTS\"."
950 echo
951 else
952 echo
953 echo "An email containing results was sent to the following addresses:"
954 echo " \"$ADDRESSES\""
955 echo
956 fi
957 test -f $DRESULTS".tar" && rm -f $DRESULTS".tar"
958 test -f $DRESULTS".tar.gz" && rm -f $DRESULTS".tar.gz"
959 fi
960 fi
961
962 # rm -f tmp_cmpnum.f a.out
963 rm -f tmp_cmpnum.c tmp_cmpnum
964
965 if test "x$CLEANUP" != xt ; then
966 cat $SUMMARY
967 if test -e tr_out.txt ; then
968 mv tr_out.txt tr_out.txt.old
969 fi
970 cat $SUMMARY > tr_out.txt
971 fi
972
973 if test "x$DELDIR" = xt ; then
974 rm -rf $DRESULTS
975 fi

  ViewVC Help
Powered by ViewVC 1.1.22